module Main (main) where
--import Parser
import TestGen

--Pretty Printing

--We want some functions to pretty print collections of test frames.

prettyPrintFrames :: [TestFrame] -> String
prettyPrintFrames frames = concat (map prettyPrintOneFrame frames)
 
--This relies, in turn on being able to pretty print a single frame.

prettyPrintOneFrame :: TestFrame -> String
prettyPrintOneFrame (i,n,choices) = i ++ (show n) ++ "\n" ++
                                   (concat [((show num) ++ " " ++ name ++ 
                                         " @" ++ (deFTag tag) ++"@" ++ "\n") | 
                                       (num,name,_,_,_,tag) <- choices]) 
                              ++ "\n"

--The FTags need to be turned into strings.

deFTag :: FTag -> String
deFTag NoFTag = ""
deFTag (FTag s) = s


readLine = getChar                >>= \ c ->
           if c == '\n' then
              return []
           else
              readLine            >>= \ cs ->
              return (c:cs)

          

main = accumulate [
          putStr "Input file name: "		>>
          readLine				>>= \ name ->
          readFile name ,
          putStr "Output file name: "          >>
          readLine ]			        >>= \ [rawTSL, outFile] ->
       writeFile outFile (prettyPrintFrames (testgen (prepare rawTSL))) 

--main=putStr "hello world\n"

--main = putStr "Input file name: \n"	       >>
--       getLine                                >>= \ name ->
--       readFile name                          >>= \ rawTSL ->
--       putStr (prettyPrintFrames (testgen (prepare rawTSL)))



--       where readName = isEOF 			>>= \ eof ->
--                       if eof then return []
--                        else
--                          getChar		>>= \ c ->
--                          if c `isIn` ['\n'] 
--                          then
--                            return []
--                          else
--                            readName	>>= \ cs ->
--                            return (c::cs)






